# -*- coding: utf-8 -*-                                                                                                 

# Copyright 2009-2010 Manik Bhattacharjee (manik-listes at altern.org)
#                                                                
# This file is part of PyVotons!.                                
#                                                                
# PyVotons! is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or   
# (at your option) any later version.                                 
#                                                                     
# PyVotons! is distributed in the hope that it will be useful,        
# but WITHOUT ANY WARRANTY; without even the implied warranty of      
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       
# GNU Affero General Public License for more details.                        
#                                                                     
# You should have received a copy of the GNU Affero General Public License   
# along with PyVotons!.  If not, see <http://www.gnu.org/licenses/>. 
#
#from pyjamas.JSONService import JSONProxy
##from simplejson import loads, dumps
#
#class ServerPython(JSONProxy):
#    def __init__(self):
#        JSONProxy.__init__(self, "ManikService.py", ["request"])

class Event:
    def __init__(self,  eventtype,  data):
        self.eventtype = eventtype
        if data is None:
            self.data = {}
        else:
            self.data = data
    def request(self,  token=None):
		if token not in self.data:
			self.data['token'] = token
		return {'type':self.eventtype,  'data': self.data}
#    def send(self,  server):
#        answ = server.request({'type':self.type,  'data': self.data},  self)
#        return answ
        
    def getVoteResults(self,  voteId):
       raise NotImplementedError
    def checkAndRegisterVote(self,  requestId, vote, userName,  answers):
        raise NotImplementedError
    def getVoteTemplate(self,  voteId):
        raise NotImplementedError
    def authenticate(self,  login,  md5pass,  shapass):
        data = {'login':login,  'md5pass':md5pass,  'shapass':shapass}
        return {'type':"authenticate", 'data':data}
    def __str__(self):
        return "<Event - " + self.eventtype + " : " + str(self.data) +">"
#        
#    def onRemoteResponse(self, response, request_info):
#        self.status.setText(response)
#
#    def onRemoteError(self, code, errobj, request_info):
#       # onRemoteError gets the HTTP error code or 0 and
#       # errobj is an jsonrpc 2.0 error dict:
#       #     {
#       #       'code': jsonrpc-error-code (integer) ,
#       #       'message': jsonrpc-error-message (string) ,
#       #       'data' : extra-error-data
#       #     }
#        message = errobj['message']
#        if code != 0:
#            self.status.setText("HTTP error %d: %s" % 
#                                (code, message))
#        else:
#            code = errobj['code']
#            self.status.setText("JSONRPC Error %s: %s" %
#                                (code, message))     
