from mod_python import Session, apache
from uuid import uuid4 as uuid
from exceptions import Exception

from simplejson import loads, dumps

import MySQLdb as DBapi

def getDBCursor(session):
    if session is None:
        raise Exception('No session provided !') 
    if session is not None and'conn' in session:
       return session['conn'].cursor()
    conn = DBapi.connect (host = "localhost",
                           user = "pyvotons",
                           passwd = "pyvotons",
                           db = "pyvotons")
    cursor = conn.cursor ()
    session['conn'] = conn
    session.save()
    return conn
   #cursor.execute ("SELECT VERSION()")
   #row = cursor.fetchone ()
   #print "server version:", row[0]
   #cursor.close ()
   #conn.close ()


def auth(req,  session):
    # Check from the DB if the login is valid
    curs = getDBcursor(session)
    nb = curs.execute("SELECT userid FROM users WHERE login=%s AND shapass=%s AND md5pass=%s",  (req["login"],  req["md5pass"],  req["shapass"]))
    if nb == 1:
        session["token"] = uuid()
        session.save()
        return session["token"]
    else:
        raise Exception("Login or password is incorrect !")

def request(params):
    #params should be a dictionnary
    return dumps({"type":'ERROR',  "message":'REQUEST NOT ANSWERED'})

def handler(req):
    session = Session.Session(req)
    json = loads(req.read())
    params = json['params']
    method = json['method'] 

    output = {'request':request}[method](params)


    try:
        session['hits'] += 1
    except:
        session['hits'] = 1

    session.save()

    req.content_type = 'text/plain'
    #req.write('REPR(json): ' +  repr(json) + '\n')
    req.write(dumps(dict(result="Appel de la methode " + str(method) + ", parametres " + params[0] + "\nSolution : "+output+"\n", error=None, id=session['hits'])))

    return apache.OK
#
#if __name__ == '__main__':
#    from jsonrpc.apacheServiceHandler import handler
#    
    
